<?php
/**
 * Copyright © 2016 Filoblu S.r.l. All rights reserved.
 */

namespace FiloBlu\Kpi\Block\Adminhtml\System\Config;

/**
 * Renderer for Event Configuration
 */

class Kpimapping extends \Magento\Config\Block\System\Config\Form\Field\FieldArray\AbstractFieldArray
{
    protected $_attributeFactory;

    public function __construct(
        \Magento\Backend\Block\Template\Context $context,
        \Magento\Catalog\Model\ResourceModel\Eav\Attribute $attributeFactory,
        array $data = []
    ) {
        $this->_attributeFactory = $attributeFactory;
        parent::__construct($context, $data);
    }

    protected $_addAfter = true;

    protected function _prepareToRender()
    {
        $catalog_attributes_coll = $this->_attributeFactory->getCollection()
            ->addFieldToFilter(\Magento\Eav\Model\Entity\Attribute\Set::KEY_ENTITY_TYPE_ID, 4);
        $catalog_attributes = array();
        foreach ($catalog_attributes_coll as $a) {
            $catalog_attributes[$a->getAttributeCode()] = $a->getFrontendLabel() . " - ({$a->getAttributeCode()})";
        }
        $catalog_attributes_block = $this->getLayout()->createBlock('Magento\Framework\View\Element\Html\Select')
            ->setId($this->_getCellInputElementId('<%- _id %>','catalog_product_attribute'))
            ->setName($this->_getCellInputElementName('catalog_product_attribute'))
            ->setClass('select')
            ->setOptions($catalog_attributes);

        /*
         * If you add or change some columns name
         * remember to resave the config (kpi/table_configuration/fields) or it will not load properly
         */
        $this->addColumn('column_name', array(
            'label' => __('Column Name')
        ));

        $this->addColumn('catalog_product_attribute', array(
            'label' => __('Product Attribute'),
            'renderer' => $catalog_attributes_block
        ));


        $this->_addAfter = false;
        $this->_addButtonLabel = __('Add attribute');
    }
 
}
